function fg_HandleButtons(src,~,this,handleAnswer)
    h = guidata(src);
    tag = get(src,"Tag");
    switch(tag)
        case {"fg_Cancel","fg_Form"}
            handleAnswer(struct("fg_Button","fg_Cancel","fg_Tag",tag));
            set(h.fg_pnl,"visible","off");
            delete(h.fg_pnl);
        case "fg_Reset"
            fg_reset(src);
        otherwise     % Ok buttons or solitary list / radio button
            fn = fieldnames(h.data);
            if strcmp(tag,"fg_Ok") || numel(fn) == 1    % case of lonely radio button
                error = {};
                for k=1:numel(fn)
                  key = char(fn(k));
                  data = h.data.(key);
                  if (~isempty(data{11}))
                    error{numel(error) + 1} = strcat(data{2}," fielderror");
                  end
                  d.(key) = this.valueOf(this,key);
                end
                if (numel(error)) > 0
                  uiwait(msgbox(error,'Form generator','modal'));
                else
                  d.fg_Button = get(src,"Tag");
                  handleAnswer(d);
                  if not(strcmp(h.staticForm,"S")) 
                    set(h.fg_pnl,"visible","off");
                    delete(h.fg_pnl); 
                  end             
                end
            end
    end
end
function fg_reset(src)
    numberRg = struct("I",'([+-]?\d+(?:\.\d+))?',"N",'([1-9]\d*)',...
                      "NS",'([+-]?[1-9]\d*)', "NF", '([+-]?\d+(?:\.\d+))?');
    template = '^A\s+A$|^A$';  % template for one or two item
    h = guidata(src);
    fn = fieldnames(h.data);
    for k=1:numel(fn)
      key = char(fn(k));
      type = h.data.(char(fn(k))){1};
      default = h.data.(key){5};
      handle = h.data.(key){9};
      if (isempty(default)) default = ""; end  % no default
      set(handle,"foregroundColor",[0 0 0]);
      h.data.(key){11} = [];    % reset error flag
      switch (type)
          case "CKB"
            set(handle,"value",strcmpi(default,"On"));
          case {"L"}
            set(handle,"value",1);
            for kList = 1:numel(h.itemsList.(key))
              if strcmp(h.itemsList.(key)(kList),default)
                set(h.data.(key){9},"value",kList);
                break;
              end
            end
          case "R"
            uData = get(handle,"userdata");
            for kList = 1:numel(h.itemsList.(key))
              if strcmp(h.itemsList.(key)(kList),default)
                set(uData(kList),"value",1);
                break;
              end
            end
          case "S"
            uData = get(handle,"userdata");
            template = strcat("%.",sprintf("%if",uData.decimals));
            set(uData.handle,"string",sprintf(template,str2double(default)));
            set(handle,"value",str2double(default));
          case "T"
            set(handle,"string",default);
            set(handle,"foregroundColor",[0 0 0]);          
          otherwise
            default = strtrim(default);
            switch (type)
              case "H"
                h.data.(key){3} = h.data.(key){5}; 
              case "I"
                [~, ~, ~, ~, answ]  = regexp(default,'([+-]?\d+(?:\.\d+)?)');
                switch numel(answ)
                  case {1,3} % random values inside the circle with radius answ{1}
                    delta = str2double(answ{1}{1});                    
                    coord = [0,0];
                    if (numel(answ) > 1) coord = [str2double(answ{2}{1}),str2double(answ{3}{1})]; end
                      default =  rValue(coord(1),delta);
                      set(h.data.(key){10},"string",rValue(coord(2),delta));            
                  case 2 % fixed values
                    default = sprintf("%i",answ{1}{1});
                    set(h.data.(key){10},"string",sprintf("%i",answ{2}{1}));
                end
              case {"N","NS","NF"}
                [~, ~, ~, ~, answ]  = regexp(default,strrep(template,'A',numberRg.(type)));
                if(numel(answ) > 0)
                    if (numel(answ{1}) > 1)
                     r = range(answ{1}{1},answ{1}{2});
                     delta = r(2) - r(1);
                     if (strcmp(type,"NF"))
                       default = rValue(r(1),delta);
                     else
                       def = randi(delta); 
                       default = sprintf("%i",def+r(1));
                     end
                   end
                else
                   set(handle,"foregroundColor",[1 0 0]);   % mark error
                   sprintf("Default of %s: '%s' is not numeric " ,key, default)
                   h.data.(key){11} = 1;  % set error tag
                end
            end  
            set(handle,"string",default);
      end
   end
   guidata(src,h)
end
function r = range(n1,n2)
  r = [min(str2double(n1),str2double(n2)) max(str2double(n1),str2double(n2))];
end
function v = rValue(coord,r)
     templ = strcat("%.",sprintf("%if",-floor(log10(r)-2)));
     v = sprintf(templ,coord + rand*(r));
end